#ifndef SUB_GENERATOR_H
#define SUB_GENERATOR_H

#include "../common/scene.h"

void subsample_render(int min_height, int max_height);

int calc_sub_sample(int x, int y, int dis);
void interpolate(int x, int y, int obj_num, int dis);
int is_close_match(int x, int y, int dis);
void table_interpolate(int x, int y, int obj_num, int dis);

#include "../common/scene.h"
#include "RayTracer.h"

class SubSamplingRayTracer : public RayTracer
{
public:
	SubSamplingRayTracer(Canvas *c) : RayTracer(c)
	{ }
	
	~SubSamplingRayTracer()
	{ }
	
	void render(SlimScene *scene);
	
protected:
	void interpolate(int x, int y, int obj_num, int dis);
	void table_interpolate(int x, int y, int obj_num, int dis);
	int is_close_match(int x, int y, int dis);
	char match_Primitive_data(intersect_data *i1, intersect_data *i2, intersect_data *i3, intersect_data *i4);
	char match_Primitive_ids(intersect_data *i1, intersect_data *i2, intersect_data *i3, intersect_data *i4);
	int match_Colors(int x, int y, int dis);
	int calc_sub_sample(int x, int y, int dis);
};

#endif
